#ifndef __ELOG_READ_HEADER_INCLUDED__
#define __ELOG_READ_HEADER_INCLUDED__

struct elog_pkt {
	struct elog *file;
	struct elog_pkthdr *hdr;
	char *decode_buf;
	char *data;
	char *generator;
	char *alert;
	size_t ofs;
};

typedef int(*proc_elogfn)(struct elog_pkt *, void *);

struct elog {
	char *map, *end;
	int fd;
	size_t maplen;
	proc_elogfn dispatch;
};

#ifndef __PLUGIN__

struct elog *elog_new(int);
void elog_free(struct elog *);
int elog_run(struct elog *, void *);
size_t elog_pkt(struct elog *, size_t, void *);
proc_elogfn elog_set_alert_fn(struct elog *, proc_elogfn);

/* Packetization API (elog_pkt.c) */
#ifdef __TARGET_HEADER_INCLUDED__
int elog_pkt_alert(struct elog_pkt *, proc_target, void *);
#endif

#endif /* __PLUGIN__ */

#endif /* __ELOG_READ_HEADER_INCLUDED__ */
