/*
 * This file is part of tcpidx
 * Copyright (c) 2003 Gianni Tedesco
 * Released under the terms of the GNU GPL version 2
*/
#ifndef __I_IDX_HEADER_INCLUDED__
#define __I_IDX_HEADER_INCLUDED__

#define FIELD_TYPE_NUM		0
#define FIELD_TYPE_STRING	1

/* Each protocol can get fields out for indexing */
#define GET_KEY_NUM(x) ((int)(*)(struct packet *, struct alert *, idx_key_t *)(x))
struct proto_field {
	const char *name;
	int type;
	union {
		int(*num)(struct packet *, struct alert *, int l, idx_key_t *);
	}get_key;
	struct proto *owner;
	void *ornament;
	struct proto_field *next;
};

struct i_field {
	const char *name;
	struct i_ordered *db;
};

struct i_idx {
	idx_ofs_t num_fields;
	idx_ofs_t cur_field;
	struct i_field field[0];
};

struct i_idx *i_idx_new(int num_fields);
int i_idx_ordered_field(struct i_idx *idx,
			const char *name,
			struct i_ordered *db);
int i_idx_write_fd(struct i_idx *idx, int fd);
void i_idx_free(struct i_idx *idx);

#endif /* __I_IDX_HEADER_INCLUDED__ */
