#ifndef __LOADER_HEADER_INCLUDED__
#define __LOADER_HEADER_INCLUDED__

#include <plugin.h>

/* Plugin loader API */
#ifndef __PLUGIN__
extern struct plugin *ld_list;

void loader_init(proc_plugin_import);
void loader_load_dir(const char *);
int loader_load(const char *);
void *loader_symbol(struct plugin *, char *);
void loader_stats(void);

void loader_perror(struct plugin *, char *, int);

struct plugin {
	struct plugin		*next;
	void			*lib;
	proc_plugin_init	init;
	proc_plugin_unload	unload;
	struct plugin_out	p;
};

struct plugin *loader_find(char *);
#endif

#endif /* __LOADER_HEADER_INCLUDED__ */
