#ifndef __PARSER_HEADER_INCLUDED__
#define __PARSER_HEADER_INCLUDED__

typedef int (*proc_parser_run)(char *);

struct parser {
	struct parser	*next;
	const char	*name;
	proc_parser_run	load_file;
};

typedef int(*proc_parser_add)(struct parser *);
typedef int(*proc_parser_setup)(char *, char *);

struct parser_api {
	size_t size;
	proc_parser_add 	parser_add;
	proc_parser_setup 	parser_setup;
	proc_args_parse 	args_parse;
	proc_sig_rule		signature_rule;
	proc_sig_criteria	signature_criteria;
	proc_sig_modifier	signature_modifier;
	proc_sig_alert		signature_alert;
	proc_sig_commit		signature_commit;
	proc_sig_abort		signature_abort;
};
typedef int (*proc_parser_load)(struct parser_api *);

#ifndef __PLUGIN__
void parser_load(void);
int parser_add(struct parser *);
int parser_setup(char *, char *);
#endif

#endif /* __PARSER_HEADER_INCLUDED__ */
