/*
 * This file is part of tcpidx
 * Copyright (c) 2003 Gianni Tedesco
 * Released under the terms of the GNU GPL version 2
*/
#ifndef __Q_FILTER_HEADER_INCLUDED__
#define __Q_FILTER_HEADER_INCLUDED__

/* Available operators */
#define QF_OP_EQ 0 /* == */
#define QF_OP_LT 1 /* < */
#define QF_OP_GT 2 /* > */
#define QF_OP_LE 3 /* <= */
#define QF_OP_GE 4 /* >= */
#define QF_OP_NE 5 /* != */
#define QF_OP_MAX 5

struct q_constraint {
	const char *field;
	idx_key_t operand;
	int operator;
};

struct q_db_filter {
	const char *field;
	idx_key_t min, max;
};

struct q_filter {
	/* pre-processed data */
	struct q_db_filter *filter;
	size_t num_filter;

	/* Result */
	idx_val_t *result;
	size_t num_recs;

	/* Initial storage format */
	struct q_constraint *constraint;
	size_t num_constraints;
	size_t num_alloc;

	int noresult;
	char *query;
};

struct q_filter *q_filter_new(size_t prealloc);
void q_filter_free(struct q_filter *qf);
void q_filter_free_result(struct q_filter *qf);
int q_filter_constraint(struct q_filter *qf, const char *field,
				int op, idx_key_t key);
int q_filter_run(struct q_filter *qf, int fd);
int q_filter_prepare(struct q_filter *qf);
int q_filter_query(struct q_filter *qf, const char *q);

#endif /* __Q_FILTER_HEADER_INCLUDED__ */
