/*
 * This file is part of tcpidx
 * Copyright (c) 2003 Gianni Tedesco
 * Released under the terms of the GNU GPL version 2
*/
#ifndef __Q_IDX_HEADER_INCLUDED__
#define __Q_IDX_HEADER_INCLUDED__

struct q_res {
	idx_ofs_t num_keys;
	idx_ofs_t num_vals;
	idx_val_t *val;
	struct idx_node *node;
	struct q_idx *field;
};

struct q_idx {
	const char *name;
	void *map, *end;
	idx_ofs_t num_keys;
	idx_ofs_t num_vals;
	int type;
};

struct q_db {
	size_t num_idx;
	void *map, *end;
	struct q_idx idx[0]; /* sorted for bsearch() */
};

struct q_db *q_idx_open(int fd);
void q_idx_close(struct q_db *q);
struct q_idx *q_idx_get(struct q_db *q, const char *name);

#endif /* __Q_IDX_HEADER_INCLUDED__ */
